<template>
  <a-spin :spinning="confirmLoading">
    <j-form-container :disabled="formDisabled">
      <a-form :form="form" slot="detail">
        <a-row>
          <a-col :span="24">
            <a-form-item label="图片" :labelCol="labelCol" :wrapperCol="wrapperCol">
              <j-image-upload isMultiple v-decorator="['pic']"></j-image-upload>
            </a-form-item>
          </a-col>
          <a-col v-if="showFlowSubmitButton" :span="24" style="text-align: center">
            <a-button @click="submitForm">提 交</a-button>
          </a-col>
        </a-row>
      </a-form>
    </j-form-container>
  </a-spin>
</template>

<script>

  import { httpAction, getAction } from '@/api/manage'
  import pick from 'lodash.pick'
  import { validateDuplicateValue } from '@/utils/util'
  import JFormContainer from '@/components/jeecg/JFormContainer'
  import JImageUpload from '@/components/jeecg/JImageUpload'

  export default {
    name: 'IostDeliveryRecordPicForm',
    components: {
      JFormContainer,
      JImageUpload,
    },
    props: {
      //流程表单data
      formData: {
        type: Object,
        default: ()=>{},
        required: false
      },
      //表单模式：true流程表单 false普通表单
      formBpm: {
        type: Boolean,
        default: false,
        required: false
      },
      //表单禁用
      disabled: {
        type: Boolean,
        default: false,
        required: false
      }
    },
    data () {
      return {
        form: this.$form.createForm(this),
        model: {},
        labelCol: {
          xs: { span: 24 },
          sm: { span: 5 },
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 },
        },
        confirmLoading: false,
        validatorRules: {
        },
        url: {
          add: "/basedata/iostDeliveryRecordPic/add",
          edit: "/basedata/iostSummarySheet/updateSummarySheetList",
          // edit: "/basedata/iostDeliveryRecordPic/edit",///basedata/iostDeliveryRecordPic/edit
          queryById: "/basedata/iostDeliveryRecordPic/queryById"
        }
      }
    },
    computed: {
      formDisabled(){
        if(this.formBpm===true){
          if(this.formData.disabled===false){
            return false
          }
          return true
        }
        return this.disabled
      },
      showFlowSubmitButton(){
        if(this.formBpm===true){
          if(this.formData.disabled===false){
            return true
          }
        }
        return false
      }
    },
    created () {
      //如果是流程中表单，则需要加载流程表单data
      this.showFlowData();
    },
    methods: {
      add () {
        this.edit({});
      },
      editR (record){
        let that = this;
        let curId = record;
        let url = `${window._CONFIG['domianURL']}/basedata/iostDeliveryRecordPic/queryById`;
        getAction(url,{id:curId}).then((res)=>{
          console.log("res")
          console.log(res)
          that.form.resetFields();
          if(res.success){
            that.model = Object.assign({}, res.result);
          }
          else
          {
            that.model = {id:curId};
          }
          that.visible = true;
          that.$nextTick(() => {
            that.form.setFieldsValue(pick(that.model,'pic'))
          })
        })
      },
      edit (record) {
        let that = this;
        let curId = record.deliveryRecordId;//.deliveryRecordId
        let url = `${window._CONFIG['domianURL']}/basedata/iostDeliveryRecordPic/queryById`;
        getAction(url,{id:curId}).then((res)=>{
          console.log("res")
          console.log(res)
          that.form.resetFields();
          if(res.success){   
            that.model = Object.assign({}, res.result);
          }
          else
          {
            that.model = {id:curId};
          }
          that.visible = true;
          that.$nextTick(() => {
            that.form.setFieldsValue(pick(that.model,'pic'))
          })
        })

      },
      //渲染流程表单数据
      showFlowData(){
        if(this.formBpm === true){
          let params = {id:this.formData.dataId};
          getAction(this.url.queryById,params).then((res)=>{
            if(res.success){
              this.edit (res.result);
            }
          });
        }
      },
      submitForm () {
        const that = this;
        // 触发表单验证
        this.form.validateFields((err, values) => {
          if (!err) {
            that.confirmLoading = true;
            let httpurl = '';
            let method = '';
            if(!this.model.id){
              httpurl+=this.url.add;
              method = 'post';
            }else{
              httpurl+=this.url.edit;
               method = 'put';
            }
            let formData = Object.assign(this.model, values);
            console.log("表单提交数据",formData)
            httpAction(httpurl,formData,method).then((res)=>{
              if(res.success){
                that.$message.success(res.message);
                that.$emit('ok');
              }else{
                that.$message.warning(res.message);
              }
            }).finally(() => {
              that.confirmLoading = false;
            })
          }
         
        })
      },
      popupCallback(row){
        this.form.setFieldsValue(pick(row,'pic'))
      },
    }
  }
</script>